#ifndef COMPILER_H
#define COMPILER_H

/*
** first "exceptions"
*/

#if defined(__SASC)
  #if !defined(_M68060)
    #if !defined(_M68040)
      #if !defined(_M68030) || !defined(_M68020)
         #define mc68000
      #else
        #define mc68020
      #endif
    #else
      #define mc68040
    #endif
  #else
    #define mc68060
  #endif
  #if defined(_M68881)
    #define __HAVE_68881__
  #endif
  #define ASM(arg) arg __asm
#elif defined(__GNUC__)
  #define REG(reg,arg) arg __asm(#reg)
  #define LREG(reg,arg) register REG(reg,arg)
  #define ALIAS(a,b) __asm(".stabs \"_" #a "\",11,0,0,0\n\t.stabs \"_" #b "\",1,0,0,0");
#endif

/*
** then "common" ones
*/

#if !defined(ASM)
  #define ASM(arg) arg
#endif
#if !defined(REG)
  #define REG(reg,arg) register __##reg arg
#endif
#if !defined(LREG)
  #define LREG(reg,arg) register arg
#endif
#if !defined(ALIAS)
  #define ALIAS(a,b)
#endif
#if !defined(CONST)
  #define CONST const
#endif
#if !defined(SAVEDS)
  #define SAVEDS __saveds
#endif
#if !defined(INLINE)
  #define INLINE static __inline
#endif
#if !defined(REGARGS)
  #define REGARGS __regargs
#endif
#if !defined(STDARGS)
  #define STDARGS __stdargs
#endif
#if defined(mc68020) || defined(mc68030) || defined(mc68040) || defined(mc68060)
  #define PLAIN(x)
  #define REQUIRES_68020(x) ((x & AFF_68020) == 0)
#else
  #define REQUIRES_68020(x) (0)
  #define PLAIN(x) x
#endif

#endif /* COMPILER_H */
